diff --git a/app/views/roles/report.rhtml b/app/views/roles/report.rhtml
new file mode 100644
index 0000000..4503256
--- /dev/null
+++ b/app/views/roles/report.rhtml
@@ -0,0 +1,54 @@
+<%= javascript "redmine-application" %>
+<% title "Permissions report" %>
+
+<% form_tag(report_roles_path, :id => 'permissions_form') do %>
+  <%= hidden_field_tag 'permissions[0]', '', :id => nil %>
+  <table class="list">
+    <thead>
+      <tr>
+        <th>Permissions</th>
+        <% @roles.each do |role| %>
+          <th>
+            <%= content_tag(role.builtin? ? 'em' : 'span', h(role.name)) %>
+            <%= link_to_function(image_tag('toggle_check.png'), "toggleCheckboxesBySelector('input.role-#{role.id}')",
+                                 :title => "Check all/Uncheck all")
+            %>
+          </th>
+        <% end %>
+      </tr>
+    </thead>
+    <tbody>
+      <% perms_by_block = @permissions.group_by {|p| p.security_block.to_s} %>
+      <% perms_by_block.keys.sort.each do |block| %>
+        <% unless block.blank? %>
+          <tr class="group open">
+            <td colspan="<%= @roles.size + 1 %>">
+              <span class="expander" onclick="toggleRowGroup(this); return false;">&nbsp;</span>
+              <%= block.humanize %>
+            </td>
+          </tr>
+        <% end %>
+        <% perms_by_block[block].each do |permission| %>
+          <tr class="<%= cycle('odd', 'even') %> permission-<%= permission.name %>">
+            <td>
+              <%= link_to_function(image_tag('toggle_check.png'), "toggleCheckboxesBySelector('.permission-#{permission.name} input')",
+                                   :title => "Check all/Uncheck all")
+              %>
+              <%= permission.name.to_s.humanize %>
+            </td>
+            <% @roles.each do |role| %>
+              <td align="center">
+                <% if role.setable_permissions.include? permission %>
+                  <%= check_box_tag "permissions[#{role.id}][]", permission.name, (role.permissions.include? permission.name),
+                    :id => nil, :class => "role-#{role.id}" %>
+                <% end %>
+              </td>
+            <% end %>
+          </tr>
+        <% end %>
+      <% end %>
+    </tbody>
+  </table>
+  <p><%= check_all_links 'permissions_form' %></p>
+  <p><%= submit_tag "Save" %></p>
+<% end %>
diff --git a/app/views/usergroups/index.html.erb b/app/views/usergroups/index.html.erb
index 34dd4cb..a849c24 100644
--- a/app/views/usergroups/index.html.erb
+++ b/app/views/usergroups/index.html.erb
@@ -9,14 +9,14 @@
   </tr>
   <% for usergroup in @usergroups %>
     <tr class="<%= cycle("even", "odd") -%>">
-      <td><%= link_to h(usergroup.name), edit_usergroup_path(usergroup) %></td>
+      <td><%= link_to_if_authorized h(usergroup.name), hash_for_edit_usergroup_path(:id => usergroup.id) %></td>
       <td><%= usergroup.users.map(&:login).to_sentence %></td>
       <td><%= usergroup.usergroups.map(&:name).to_sentence %></td>
       <td align="right">
-        <%= link_to "Destroy", usergroup, :confirm => 'Are you sure?', :method => :delete %>
+        <%= display_link_if_authorized "Destroy", hash_for_usergroup_path(:id => usergroup, :auth_action => :destroy), :confirm => "Delete #{usergroup.name}?", :method => :delete %>
       </td>
     </tr>
   <% end %>
 </table>
 
-<p><%= link_to("New Usergroup", new_usergroup_path) %></p>
+<p><%= display_link_if_authorized "New Usergroup", hash_for_new_usergroup_path %></p>
diff --git a/app/views/users/_filters.html.erb b/app/views/users/_filters.html.erb
new file mode 100644
index 0000000..2c7645f
--- /dev/null
+++ b/app/views/users/_filters.html.erb
@@ -0,0 +1,52 @@
+<td>
+  <% field_set_tag("Select the subset of all hosts to which these permissions apply", :id => "filters", :style => @user.filtering? ? "display:inline;" : "display:none") do %>
+    <table>
+      <tr>
+        <td>
+          Select
+          <%= f.check_box :filter_on_owner %>
+        </td>
+        <td colspan="2">
+          <% field_set_tag "Owned hosts" do %>
+            <%= @user.hosts.empty? ? "None" : @user.hosts.to_sentence %>
+          <% end -%>
+        </td>
+      </tr>
+      <tr>
+        <td>
+          <%= f.select :domains_andor, [["in domain", "and"], ["plus all", "or"]] %>
+        </td>
+        <td style="width:100%">
+          <% field_set_tag "Domain hosts" do %>
+            <%= edit_habtm @user, Domain %>
+          <% end %>
+        </td>
+      </tr>
+      <tr>
+        <td>
+          <%= f.select :hostgroups_andor, [["must be", "and"], ["plus all", "or"]] %>
+        </td>
+        <td>
+          <% field_set_tag "Hostgroup hosts" do %>
+            <%= edit_habtm @user, Hostgroup %>
+          <% end %>
+        </td>
+      </tr>
+      <tr>
+        <td>
+          <%= f.select :facts_andor, [["must match", "and"], ["plus all", "or"]] %>
+        </td>
+        <td>
+          <% field_set_tag "Fact filters" do %>
+            <%= render :partial => "user_facts", :locals => {:f => f} %>
+          <% end %>
+        </td>
+      </tr>
+    </table>
+  <% end -%>
+  <%= link_to_function("Display host filters", nil, :id => "more_link") do |page|
+    page['filters'].visual_effect :blindDown
+    page[:more_link].hide
+  end unless @user.filtering?
+%>
+</td>
diff --git a/app/views/users/_form.html.erb b/app/views/users/_form.html.erb
index 610d05a..8b17b54 100644
--- a/app/views/users/_form.html.erb
+++ b/app/views/users/_form.html.erb
@@ -2,34 +2,50 @@
   <%= f.error_messages %>
   <table border="0">
     <tr>
-      <td style="width:1%"> Login</td> <td> <%= f.text_field :login %> </td>
-    </tr>
-    <tr>
-      <td> First name</td> <td> <%= f.text_field :firstname %> </td>
-    </tr>
-    <tr>
-      <td> Last name</td> <td> <%= f.text_field :lastname %> </td>
-    </tr>
-    <tr>
-      <td> Mail</td> <td> <%= f.text_field :mail %> </td>
-    </tr>
-    <tr>
-      <td nowrap> Authorized by</td>
-      <td>
-        <%= f.collection_select :auth_source_id, AuthSource.all.delete_if{|a| a.to_label.nil?}, :id, :to_label, {:include_blank => true}  %>
-      </td>
-    </tr>
-    <tr id="password" <%= 'style="display:none"' unless @user.manage_password? -%>>
-      <td> Password </td>
-      <td> <%= password_field :user, :password %>	</td>
-		</tr>
-		<tr id="verification" <%= 'style="display:none"' unless @user.manage_password? -%>>
-      <td>  Verification </td>
-      <td>  <%= password_field :user, :password_confirmation %> 	</td>
-    </tr>
-    <tr>
-      <td colspan="2"> Administrator <%= f.check_box :admin %> </td>
-    </tr>
+      <td colspan="2">
+        <table>
+          <tr>
+            <td style="width:1%"> Login</td> <td> <%= f.text_field :login %> </td>
+          </tr>
+          <tr>
+            <td> First name</td> <td> <%= f.text_field :firstname %> </td>
+          </tr>
+          <tr>
+            <td> Last name</td> <td> <%= f.text_field :lastname %> </td>
+          </tr>
+          <tr>
+            <td> Mail</td> <td> <%= f.text_field :mail %> </td>
+          </tr>
+          <tr>
+            <td nowrap> Authorized by</td>
+            <td>
+              <%= f.collection_select :auth_source_id, AuthSource.all.delete_if{|a| a.to_label.nil?}, :id, :to_label, {:include_blank => true}  %>
+            </td>
+          </tr>
+          <tr id="password" <%= 'style="display:none"' unless @user.manage_password? -%>>
+            <td> Password </td>
+            <td> <%= password_field :user, :password %>  </td>
+          </tr>
+          <tr id="verification" <%= 'style="display:none"' unless @user.manage_password? -%>>
+            <td>  Verification </td>
+            <td>  <%= password_field :user, :password_confirmation %>   </td>
+          </tr>
+          <% unless @minimal_edit -%>
+          <tr>
+            <td> Administrator</td><td><%= f.check_box :admin -%> </td>
+          </tr>
+          <% end -%>
+        </table>
+      </td>  
+    </tr>
+	<tr>
+	  <td colspan="2">
+	    <% field_set_tag "Roles" do %>
+	      <%= edit_habtm @user, Role.givable %>
+	    <% end %>
+	  </td>
+	</tr>
+    <%= render("filters", :f => f) unless @minimal_edit -%>
     <tr>
       <td colspan="2"> <%= f.submit "Submit" %> </td>
     </tr>
diff --git a/app/views/users/_user_fact.html.erb b/app/views/users/_user_fact.html.erb
new file mode 100644
index 0000000..9ab0252
--- /dev/null
+++ b/app/views/users/_user_fact.html.erb
@@ -0,0 +1,12 @@
+<table class="fields">
+  <tr>
+    <td>Name</td>
+    <td> <%= f.collection_select :fact_name_id, Puppet::Rails::FactName.all.sort, :id, :name, :size => 10 %> </td>
+    <td> <%= f.select :operator, %w{= !=  > >= < <= } %></td>
+    <td>Value</td>
+    <td>
+      <%= f.text_field :criteria, :size => 75 %>
+      <%= authorized_for(params[:controller], params[:action]) ? link_to_remove_fields("remove", f) : "" %>
+    </td>
+  </tr>
+</table>
diff --git a/app/views/users/_user_facts.html.erb b/app/views/users/_user_facts.html.erb
new file mode 100644
index 0000000..7a63140
--- /dev/null
+++ b/app/views/users/_user_facts.html.erb
@@ -0,0 +1,4 @@
+<% f.fields_for :user_facts do |builder| -%>
+  <%= render "user_fact", :f => builder %>
+<% end -%>
+<p><%= authorized_for(params[:controller], params[:action]) ? link_to_add_fields("Add a fact filter", f, :user_facts, "user_fact") : "Add a fact filter" %></p>
diff --git a/app/views/users/index.html.erb b/app/views/users/index.html.erb
index 979759e..e964135 100644
--- a/app/views/users/index.html.erb
+++ b/app/views/users/index.html.erb
@@ -13,14 +13,14 @@
   </tr>
   <% for user in @users %>
     <tr class="<%= cycle("even", "odd")-%>" >
-      <td><%=link_to h(user.login), edit_user_path(user) %></td>
+      <td><%=link_to_if_authorized h(user.login), hash_for_edit_user_path(:id => user) %></td>
       <td><%=h user.firstname %></td>
       <td><%=h user.lastname %></td>
       <td><%=h user.mail %></td>
       <td><%=admin_column user %></td>
-      <td><%=h last_login_on_column(user) %></td>
-      <td><%=h auth_source_column(user) %></td>
-      <td><%= link_to "Destroy", user, :confirm => 'Are you sure?', :method => :delete %></td>
+      <td><%=h last_login_on_column(user)%></td>
+      <td><%=h auth_source_column(user)%></td>
+      <td><%= display_link_if_authorized "Destroy", hash_for_user_path(:id => user, :auth_action => :destroy), :confirm => "Delete #{user.name}?", :method => :delete %></td>
     </tr>
   <% end %>
 </table>
@@ -28,4 +28,4 @@
 <%= page_entries_info @users %>
 <%= will_paginate @users %>
 
-<p><%= link_to "New User", new_user_path %></p>
+<p><%= display_link_if_authorized "New User", hash_for_new_user_path %></p>
diff --git a/config/environments/test.rb b/config/environments/test.rb
index 2b35a53..1fa7765 100644
--- a/config/environments/test.rb
+++ b/config/environments/test.rb
@@ -1,6 +1,6 @@
 require 'shoulda'
 # Settings specified here will take precedence over those in config/environment.rb
-
+require 'shoulda'
 # The test environment is used exclusively to run your application's
 # test suite.  You never need to work with it otherwise.  Remember that
 # your test database is "scratch space" for the test suite and is wiped
diff --git a/config/initializers/foreman.rb b/config/initializers/foreman.rb
index 8c92765..55f0252 100644
--- a/config/initializers/foreman.rb
+++ b/config/initializers/foreman.rb
@@ -1,3 +1,4 @@
+require 'access_permissions'
 require 'puppet'
 require 'puppet/rails'
 require 'gchart'
@@ -14,6 +15,9 @@ $puppet = Puppet.settings.instance_variable_get(:@values) if Rails.env == "test"
 
 SETTINGS[:login] ||= SETTINGS[:ldap]
 
+# We load the default settings for the roles if they are not already present
+Foreman::DefaultData::Loader.load(false)
+
 # Add an empty method to nil. Now no need for if x and x.empty?. Just x.empty?
 class NilClass
   def empty?
@@ -22,6 +26,9 @@ class NilClass
 end
 
 class ActiveRecord::Base
+  def <=>(other)
+    self.name <=> other.name
+  end
 
   def update_single_attribute(attribute, value)
     connection.update(
diff --git a/config/initializers/puppet.rb b/config/initializers/puppet.rb
index f84e7ea..7ef4608 100644
--- a/config/initializers/puppet.rb
+++ b/config/initializers/puppet.rb
@@ -7,6 +7,12 @@ end
 class ParamValue < Puppet::Rails::ParamValue
 end
 
+# We reopen the class and add the associations here as we canot subclass it in app/models as this breaks puppet internals
+class Puppet::Rails::FactName
+  has_many :user_facts
+  has_many :users, :through => :user_facts
+end
+
 # workaround for puppet bug http://projects.reductivelabs.com/issues/3949
 if Facter.puppetversion == "0.25.5"
   begin
diff --git a/config/routes.rb b/config/routes.rb
index 2c7c014..cc9b9b0 100644
--- a/config/routes.rb
+++ b/config/routes.rb
@@ -35,6 +35,7 @@ ActionController::Routing::Routes.draw do |map|
   map.resources :environments, :collection => {:import_environments => :get, :obsolete_and_new => :post}
   map.resources :fact_values
   map.resources :ptables
+  map.resources :roles, :collection => {:report => [:get, :post]}
   map.resources :auth_source_ldaps
   map.resources :users, :collection => {:login => [:get, :post], :logout => :get, :auth_source_selected => :get}
   #default
diff --git a/db/migrate/20100629093200_create_roles.rb b/db/migrate/20100629093200_create_roles.rb
new file mode 100644
index 0000000..24d9be0
--- /dev/null
+++ b/db/migrate/20100629093200_create_roles.rb
@@ -0,0 +1,23 @@
+class CreateRoles  < ActiveRecord::Migration
+  def self.up
+    add_column :users, :role_id, :integer
+    create_table "roles", :force => true do |t|
+      t.column "name",        :string,  :limit => 30
+      t.column "builtin",     :integer
+      t.column "permissions", :text
+    end
+
+    create_table :user_roles do |t|
+      t.column :user_id, :integer
+      t.column :role_id, :integer
+      t.columm :inherited_from, :integer
+    end
+
+  end
+
+  def self.down
+    drop_table :user_roles
+    drop_table :roles
+    remove_column :users, :role_id
+  end
+end
diff --git a/db/migrate/20100701081235_add_user_domains_and_hostgroups.rb b/db/migrate/20100701081235_add_user_domains_and_hostgroups.rb
new file mode 100644
index 0000000..752a10a
--- /dev/null
+++ b/db/migrate/20100701081235_add_user_domains_and_hostgroups.rb
@@ -0,0 +1,20 @@
+# To suport "Edit my domain" and "edit my hostgroup" security access control we need
+# a mechanism to associate a user with some domains and hostgroups
+class AddUserDomainsAndHostgroups < ActiveRecord::Migration
+  def self.up
+    create_table :user_domains, :id => false do |t|
+      t.references :user
+      t.references :domain
+    end
+      
+    create_table :user_hostgroups, :id => false do |t|
+      t.references :user
+      t.references :hostgroup
+    end
+  end
+
+  def self.down
+    drop_table :user_domains
+    drop_table :user_hostgroups
+  end
+end
diff --git a/db/migrate/20100822072954_create_user_facts.rb b/db/migrate/20100822072954_create_user_facts.rb
new file mode 100644
index 0000000..1020d7a
--- /dev/null
+++ b/db/migrate/20100822072954_create_user_facts.rb
@@ -0,0 +1,18 @@
+# To suport "Edit my domain" and "edit my hostgroup" security access control we need
+# a mechanism to associate a user with a fact and a criria for thet fact to evaluate against
+class CreateUserFacts < ActiveRecord::Migration
+  def self.up
+    create_table :user_facts do |t|
+      t.references :user
+      t.references :fact_name
+      t.string     :criteria, :limit => 255
+      t.string     :operator, :limit => 3, :default => "="
+      t.string     :andor,    :limit => 3, :default => "or"
+      t.timestamps
+    end
+  end
+
+  def self.down
+    drop_table :user_facts
+  end
+end
diff --git a/db/migrate/20100914092104_add_my_booleans_to_user.rb b/db/migrate/20100914092104_add_my_booleans_to_user.rb
new file mode 100644
index 0000000..d0221ac
--- /dev/null
+++ b/db/migrate/20100914092104_add_my_booleans_to_user.rb
@@ -0,0 +1,13 @@
+class AddMyBooleansToUser < ActiveRecord::Migration
+  def self.up
+    add_column :users, :domains_andor,    :string, :limit => 3, :default => "or"
+    add_column :users, :hostgroups_andor, :string, :limit => 3, :default => "or"
+    add_column :users, :facts_andor,      :string, :limit => 3, :default => "or"
+  end
+
+  def self.down
+    remove_column :users, :facts_andor
+    remove_column :users, :hostgroups_andor
+    remove_column :users, :domains_andor
+  end
+end
diff --git a/db/migrate/20101103150254_add_owned_filter_to_user.rb b/db/migrate/20101103150254_add_owned_filter_to_user.rb
new file mode 100644
index 0000000..192dd35
--- /dev/null
+++ b/db/migrate/20101103150254_add_owned_filter_to_user.rb
@@ -0,0 +1,9 @@
+class AddOwnedFilterToUser < ActiveRecord::Migration
+  def self.up
+    add_column :users, :filter_on_owner, :boolean
+  end
+
+  def self.down
+    remove_column :users, :filter_on_owner
+  end
+end
diff --git a/lib/access_permissions.rb b/lib/access_permissions.rb
new file mode 100644
index 0000000..81fdbbf
--- /dev/null
+++ b/lib/access_permissions.rb
@@ -0,0 +1,143 @@
+require 'foreman/access_control'
+
+# Permissions
+Foreman::AccessControl.map do |map|
+  map.security_block :architectures do |map|
+    map.permission :view_architectures,    {:architectures => [:index, :show]}
+    map.permission :create_architectures,  {:architectures => [:new, :create]}
+    map.permission :edit_architectures,    {:architectures => [:edit, :update]}
+    map.permission :destroy_architectures, {:architectures => [:destroy]}
+  end
+
+  map.security_block :authentication_providers do |map|
+    map.permission :view_authenticators,    {:auth_source_ldaps => [:index, :show]}
+    map.permission :create_authenticators,  {:auth_source_ldaps => [:new, :create]}
+    map.permission :edit_authenticators,    {:auth_source_ldaps => [:edit, :update]}
+    map.permission :destroy_authenticators, {:auth_source_ldaps => [:destroy]}
+  end
+
+  map.security_block :environments do |map|
+    map.permission :view_environments,    {:environments => [:index, :show]}
+    map.permission :create_environments,  {:environments => [:new, :create]}
+    map.permission :edit_environments,    {:environments => [:edit, :update]}
+    map.permission :destroy_environments, {:environments => [:destroy]}
+    map.permission :import_environments,  {:environments => [:import_environments]}
+  end
+
+  map.security_block :external_variables do |map|
+    map.permission :view_external_variables,    {:lookup_keys => [:index, :show]}
+    map.permission :create_external_variables,  {:lookup_keys => [:new, :create]}
+    map.permission :edit_external_variables,    {:lookup_keys => [:edit, :update]}
+    map.permission :destroy_external_variables, {:lookup_keys => [:destroy]}
+  end
+  
+  map.security_block :domains do |map|
+    map.permission :view_domains,       {:domains => [:index, :show]}
+    map.permission :create_domain,      {:domains => [:new, :create]}
+    map.permission :edit_domains,       {:domains => [:edit, :update]}
+    map.permission :destroy_domains,    {:domains => [:destroy]}
+  end
+
+  map.security_block :global_variables do |map|
+    map.permission :view_globals,    {:common_parameters => [:index, :show]}
+    map.permission :create_globals,  {:common_parameters => [:new, :create]}
+    map.permission :edit_globals,    {:common_parameters => [:edit, :update]}
+    map.permission :destroy_globals, {:common_parameters => [:destroy]}
+  end
+
+  map.security_block :hostgroups do |map|
+    map.permission :view_hostgroups,       {:hostgroups => [:index, :show]}
+    map.permission :create_hostgroups,     {:hostgroups => [:new, :create]}
+    map.permission :edit_hostgroups,       {:hostgroups => [:edit, :update]}
+    map.permission :destroy_hostgroups,    {:hostgroups => [:destroy]}
+  end
+
+  map.security_block :hosts do |map|
+    map.permission :view_hosts,    {:hosts => [:index, :show], :dashboard => [:OutOfSync, :errors, :active]}
+    map.permission :create_hosts,  {:hosts => [:new, :create, :clone]}
+    map.permission :edit_hosts,    {:hosts => [:edit, :update, :multiple_actions, :reset_multiple, :select_multiple_hostgroup, :select_multiple_environment, :submit_multiple_disable,
+                                                 :multiple_parameters, :multiple_disable, :multiple_enable, :update_multiple_environment, :update_multiple_hostgroup, :update_multiple_parameters]}
+    map.permission :destroy_hosts, {:hosts => [:destroy, :multiple_actions, :reset_multiple, :multiple_destroy, :submit_multiple_destroy]}
+  end 
+  
+  map.security_block :medias do |map|
+    map.permission :view_medias,    {:medias => [:index, :show]}
+    map.permission :create_medias,  {:medias => [:new, :create]}
+    map.permission :edit_medias,    {:medias => [:edit, :update]}
+    map.permission :destroy_medias, {:medias => [:destroy]}
+  end
+
+  map.security_block :models do |map|
+    map.permission :view_models,    {:models => [:index, :show]}
+    map.permission :create_models,  {:models => [:new, :create]}
+    map.permission :edit_models,    {:models => [:edit, :update]}
+    map.permission :destroy_models, {:models => [:destroy]}
+  end
+
+  map.security_block :operatingsystems do |map|
+    map.permission :view_operatingsystems,    {:operatingsystems => [:index, :show]}
+    map.permission :create_operatingsystems,  {:operatingsystems => [:new, :create]}
+    map.permission :edit_operatingsystems,    {:operatingsystems => [:edit, :update]}
+    map.permission :destroy_operatingsystems, {:operatingsystems => [:destroy]}
+  end
+
+  map.security_block :partition_tables do |map|
+    map.permission :view_ptables,    {:ptables => [:index, :show]}
+    map.permission :create_ptables,  {:ptables => [:new, :create]}
+    map.permission :edit_ptables,    {:ptables => [:edit, :update]}
+    map.permission :destroy_ptables, {:ptables => [:destroy]}
+  end
+
+  map.security_block :puppetclasses do |map|
+    map.permission :view_puppetclasses,    {:puppetclasses => [:index, :show]}
+    map.permission :create_puppetclasses,  {:puppetclasses => [:new, :create]}
+    map.permission :edit_puppetclasses,    {:puppetclasses => [:edit, :update]}
+    map.permission :destroy_puppetclasses, {:puppetclasses => [:destroy]}
+    map.permission :import_puppetclasses,  {:puppetclasses => [:import_environments]}
+  end
+
+  map.security_block :usergroups do |map|
+    map.permission :view_usergroups,    {:usergroups => [:index, :show]}
+    map.permission :create_usergroups,  {:usergroups => [:new, :create]}
+    map.permission :edit_usergroups,    {:usergroups => [:edit, :update]}
+    map.permission :destroy_usergroups, {:usergroups => [:destroy]}
+  end
+
+  map.security_block :users do |map|
+    map.permission :view_users,    {:users => [:index, :show]}
+    map.permission :create_users,  {:users => [:new, :create]}
+    map.permission :edit_users,    {:users => [:edit, :update]}
+    map.permission :destroy_users, {:users => [:destroy]}
+  end
+
+  map.security_block :settings_menu do |map|
+    map.permission :access_settings,  {:home => [:settings]}
+  end
+  
+  map.security_block :dashboard do |map|
+    map.permission :access_dashboard, {:dashboard => [:index]}
+  end
+  
+  map.security_block :reports do |map|
+    map.permission :view_reports,    {:reports     => [:index, :show]}
+    map.permission :destroy_reports, {:reports     => [:destroy]}
+  end
+  
+  map.security_block :facts do |map|
+    map.permission :view_facts,       {:fact_values => [:index, :show]}
+  end
+  
+  map.security_block :audit_logs do |map|
+    map.permission :view_audit_logs,  {:audits      => [:index, :show]}
+  end
+  map.security_block :statistics do |map|
+    map.permission :view_statistics,  {:statistics  => [:index, :show]}
+  end
+
+  #map.permission :edit_environment_hosts, {:hosts => [:new, :create, :update]}, :require => :loggedin
+  
+#  map.project_module :documents do |map|
+#    map.permission :manage_documents, {:documents => [:new, :edit, :destroy, :create_attachment]}, :require => :loggedin
+#    map.permission :view_documents, :documents => [:index, :show, :download]
+#  end
+end
diff --git a/lib/foreman/access_control.rb b/lib/foreman/access_control.rb
new file mode 100644
index 0000000..cb9d5a7
--- /dev/null
+++ b/lib/foreman/access_control.rb
@@ -0,0 +1,120 @@
+# redMine - project management software
+# Copyright (C) 2006-2007  Jean-Philippe Lang
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+# 
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+module Foreman
+  module AccessControl
+
+    class << self
+      def map
+        mapper = Mapper.new
+        yield mapper
+        @permissions ||= []
+        @permissions += mapper.mapped_permissions
+      end
+
+      def permissions
+        @permissions
+      end
+
+      # Returns the permission of given name or nil if it wasn't found
+      # Argument should be a symbol
+      def permission(name)
+        permissions.detect {|p| p.name == name}
+      end
+
+      # Returns the actions that are allowed by the permission of given name
+      def allowed_actions(permission_name)
+        perm = permission(permission_name)
+        perm ? perm.actions : []
+      end
+
+      def public_permissions
+        @public_permissions ||= @permissions.select {|p| p.public?}
+      end
+
+      def members_only_permissions
+        @members_only_permissions ||= @permissions.select {|p| p.require_member?}
+      end
+
+      def loggedin_only_permissions
+        @loggedin_only_permissions ||= @permissions.select {|p| p.require_loggedin?}
+      end
+
+      def available_security_blocks
+        @available_security_blocks ||= @permissions.collect(&:security_block).uniq.compact
+      end
+
+      def blocks_permissions(modules)
+        @permissions.select {|p| p.security_block.nil? || modules.include?(p.security_block.to_s)}
+      end
+    end
+
+    class Mapper
+      def initialize
+        @security_block = nil
+      end
+
+      def permission(name, hash, options={})
+        @permissions ||= []
+        options.merge!(:security_block => @security_block)
+        @permissions << Permission.new(name, hash, options)
+      end
+
+      def security_block(name, options={})
+        @security_block = name
+        yield self
+        @security_block = nil
+      end
+
+      def mapped_permissions
+        @permissions
+      end
+    end
+
+    class Permission
+      attr_reader :name, :actions, :security_block
+
+      def initialize(name, hash, options)
+        @name = name
+        @actions = []
+        @public = options[:public] || false
+        @require = options[:require]
+        @security_block = options[:security_block]
+        hash.each do |controller, actions|
+          if actions.is_a? Array
+            @actions << actions.collect {|action| "#{controller}/#{action}"}
+          else
+            @actions << "#{controller}/#{actions}"
+          end
+        end
+        @actions.flatten!
+      end
+
+      def public?
+        @public
+      end
+
+      def require_member?
+        @require && @require == :member
+      end
+
+      def require_loggedin?
+        @require && (@require == :member || @require == :loggedin)
+      end
+    end
+  end
+end
diff --git a/lib/foreman/controller/environments.rb b/lib/foreman/controller/environments.rb
index 19268b1..7d663cb 100644
--- a/lib/foreman/controller/environments.rb
+++ b/lib/foreman/controller/environments.rb
@@ -29,17 +29,4 @@ module Foreman::Controller::Environments
     end
   end
 
-  protected
-  def no_puppetclass_documentation_handler(exception)
-    if exception.message =~ /No route matches "\/puppet\/rdoc\/([^\/]+)\/classes\/(.+?)\.html/
-      render :template => "puppetclasses/no_route", :locals => {:environment => $1, :name => $2.gsub("/","::")}, :layout => false
-    else
-      if local_request?
-        rescue_action_locally exception
-      else
-        rescue_action_in_public exception
-      end
-    end
-  end
-
 end
